const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const videoService = require('./video.service');

router.post('/create', authorize(), create);
router.get('/', authorize(), getAll);
router.get('/filter', authorize(), filter);
router.get('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    videoService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
    videoService.getAll(req.query)
        .then(result => res.json(result))
        .catch(next);
}

function filter(req, res, next) {
    videoService.filter(req.query)
        .then(result => res.json(result))
        .catch(next);
}

function option(req, res, next) {
    videoService.option()
        .then(result => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    videoService.count()
        .then(result => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    videoService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    videoService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    videoService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
